﻿init python:
    from copy import copy
    class army_unit:
        def __init__(self, name, image, strength, cost = 0, type = None):
            self.name = name
            self.image = image
            self.strength = strength
            self.type = type
            self.cost = cost
            self.x = 0
            self.y = 0
            self.r = renpy.random.randint(0,360)
    class army_battle:
        def __init__(self, name, x, y, r):
            self.name = name
            self.x = x
            self.y = y
            self.r = r
            self.enemy = []
            self.ally = []
    class table_class:
        def __init__(self):
            self.barracks = []
            self.gold = 3004
            self.army = []
            self.holding = None
            self.side = []
            self.battles = []
            self.training = []
            self.taxes = 0
        def pick(self, piece, battle):
            if battle:
                battle.ally.remove(piece)
            else:
                self.army.remove(piece)
            self.holding = piece
        def put(self, battle):
            if self.holding:
                battle.ally.append(self.holding)
                self.holding = None
        def set_train(self, n):
            self.barracks[n][2] = not self.barracks[n][2]
        def tick(self, min = True):
            if min:
                calendar.tick()
                if calendar.minute == 0:
                    self.train()
            else:
                calendar.hour_tick()
                self.train()
            if calendar.hour == 18:
                self.taxes += renpy.random.randint(400, 1000)
            elif calendar.hour == 6:
                self.start_battles()
        def train(self):
                for n,i in enumerate(self.barracks):
                    if i[2]:
                        if self.gold >= i[0].cost:
                            self.barracks[n][1] += 1
                            self.gold -= i[0].cost
        def collect_taxes(self):
            self.gold += self.taxes
            self.taxes = 0
        def deploy(self, n):
            self.put_down()
            strength = self.barracks[n][0].strength
            if self.barracks[n][1] >= strength:
                self.barracks[n][1] -= strength
                self.holding = copy(self.barracks[n][0])
        def put_down(self):
            self.army.append(self.holding)
            self.holding = None


        def start_battles(self):
            pass



transform place_piece(x, y, r, t = .2):
    rotate_pad False
    ease t xpos x ypos y rotate r
transform zoom(z):
    zoom z
transform rotate(r):
    rotate_pad False
    rotate r

default war_room = table_class()
screen war_room_screen(g = war_room):
    add "table"
    add "pusher" at place_piece(200, -200, 260, 0)
    add "pusher" at place_piece(1200, 250, 120, 0)

    for n,i in enumerate(g.army):
        button pos g.side[n] anchor .5,.5:
            at rotate(i.r)
            fixed fit_first True:
                at zoom(.5)
                add "green_pad"
                add i.image
            action Function(g.pick, i, None)

    for j in g.battles:
        frame anchor .5,.5 xysize 25,25 background "table_coin":
            button align .5,.5 xysize 200,200:
                background None
                hover_background "#fff6"
                action Function(g.put, j)
            at place_piece(j.x, j.y, j.r)
            hbox yoffset -120 align .5,.5 spacing -10:
                for i in j.enemy:
                    if i.type == "Boss":
                        button align .5,.5 focus_mask True:
                            fixed fit_first True:
                                at zoom(.5)
                                add "red_pad"
                                add i.image
                            action Function(g.pick, i, j)
            hbox yoffset -50 align .5,.5 spacing -30:
                for i in j.enemy:
                    if i.type == None:
                        button align .5,.5 focus_mask True:
                            fixed fit_first True:
                                at zoom(.5)
                                add "red_pad"
                                add i.image
                            action Function(g.pick, i, j)
            hbox yoffset 120 align .5,.5 spacing -10:
                at rotate(180)
                for i in j.ally:
                    if i.type == "Boss":
                        button align .5,.5 focus_mask True:
                            fixed fit_first True:
                                at zoom(.5)
                                add "green_pad"
                                add i.image
                            action Function(g.pick, i, j)
            hbox yoffset 50 align .5,.5 spacing -30:
                at rotate(180)
                for i in j.ally:
                    if i.type == None:
                        button align .5,.5 focus_mask True:
                            fixed fit_first True:
                                at zoom(.5)
                                add "green_pad"
                                add i.image
                            action Function(g.pick, i, j)
    
    default mouse_pos = (0,0)
    if g.holding:
        timer .02 repeat True action SetScreenVariable("mouse_pos", renpy.get_mouse_pos())
        fixed:
            fit_first True anchor .5,.5 pos mouse_pos
            add g.holding.image
    else:
        timer .02 action SetScreenVariable("mouse_pos", (-300,-300))
    add "lights"
    add "table_hud"
    default speed = "→"
    vbox align 1.0,.5 xoffset -10:
        if speed == "→":
            timer 2 repeat True action Function(g.tick)
        elif speed == "⇉":
            timer 2 repeat True action Function(g.tick, False)
        text "Day: {}".format(calendar.play_day) xalign .5
        # text "{}".format(calendar.year) xalign .5
        text "{} {}".format(calendar.month_day, calendar.months[calendar.month][0]) xalign .5
        text "{}:{}".format(calendar.hour, calendar.minute) xalign .5
    button align 1.0,.5 yoffset 150:
        fixed fit_first True:
            add "table_button"
            text speed align .5,.5 size 50
        if speed == "→":
            action SetScreenVariable("speed", "⇉") # →⇉⇶
        elif speed == "⇉":
            action SetScreenVariable("speed", "↛")
        else:
            action SetScreenVariable("speed", "→")
    button align 1.0,.5 yoffset -150:
        fixed fit_first True:
            add "table_button"
            hbox spacing -30 align .5,.5:
                text "☀" size 50  align .5,.5
                text "→" align .5,.5 size 50 yoffset -2
        action Show("skip_to_next_day", g = g)
    vbox align .0,.5:
        hbox spacing 10:
            text str(g.gold)
            text _("Gold")
        for n,i in enumerate(g.barracks):
            vbox:
                hbox spacing 10:
                    add i[0].image at zoom(.3)
                    text i[0].name size 24 align .5,.5
                    text str(i[1]) size 24 align .5,.5
                hbox spacing 10:
                    button padding 10,10:
                        background "#fff6" selected_background "#4fff7b66"
                        hbox spacing 10:
                            text _("Train") size 24
                            text "{}G".format(i[0].cost) size 24
                        action Function(g.set_train, n), SelectedIf(i[2])
                    button background "#fff6" padding 10,10:
                        text _("Deploy") size 24
                        action Function(g.deploy, n)

    if g.taxes:
        button align 1.0,0.0:
            hbox spacing 10:
                text "Collect {} taxes".format(g.taxes) align .5,.5 size 24
                fixed fit_first True:
                    add "table_button"
                    text "$$" align .5,.5
            action Function(g.collect_taxes)


screen skip_to_next_day(g):
    modal True
    default ticks = 24
    text str(ticks) align .5,.5
    if ticks > 0:
        timer .2 repeat True action Function(g.tick, False), SetScreenVariable("ticks", ticks - 1)
    else:
        timer .4 action Hide("skip_to_next_day")

screen table_battle(g):
    modal True











define soldiers = army_unit(
    "Soldiers",
    "soldiers",
    200,
    40,
    )
define amazons = army_unit(
    "Amazons",
    "amazons",
    300,
    90,
    )
define angels = army_unit(
    "Angels",
    "angels",
    400,
    120,
    )
define hobbits = army_unit(
    "Hobbits",
    "hobbits",
    150,
    40,
    )
define rogues = army_unit(
    "Rogues",
    "rogues",
    210,
    200,
    )

define dwarf_king = army_unit(
    "Dwarf king",
    "dwarf_king",
    50,
    1000,
    "Boss",
    )
define croc_knight = army_unit(
    "Croc knight",
    "croc_knight",
    40,
    1000,
    "Boss",
    )
define lancer = army_unit(
    "Lancer",
    "lancer",
    60,
    1000,
    "Boss",
    )

define boars = army_unit(
    "Boars",
    "boars",
    250,
    )
define death_knights = army_unit(
    "Death knights",
    "death_knights",
    300,
    )
define nagas = army_unit(
    "Nagas",
    "nagas",
    180,
    )
define orcs = army_unit(
    "Orcs",
    "orcs",
    300,
    )
define skeletons = army_unit(
    "Skeletons",
    "skeletons",
    170,
    )
define orc_king = army_unit(
    "Orc king",
    "orc_king",
    65,
    1000,
    "Boss",
    )

default gen = Character("General")
default spy = Character("Spy")
default kin = Character("King Orrad")
label war_room_example:
    $ war_room.army = [
        soldiers, amazons, angels, boars, hobbits, rogues
    ]
    $ war_room.barracks = [
        [soldiers, 300, False],
        [amazons, 300, False],
        [hobbits, 300, False],
        [rogues, 300, False],
    ]
    $ war_room.side = [
        (1530, 154), (1644, 166), (1532, 262), (1493, 431), (1644, 477), (1539, 671),
        (1662, 726), (1599, 833), (1530, 947), (1381, 956), (1134, 946),
        (967, 933), (743, 947), (470, 943),(281, 778), (290, 553), (1635, 602),
        (608, 937),
    ]
    $ renpy.random.shuffle(war_room.side)

    default capital = army_battle("Capital", 1082, 352, 210)
    $ war_room.battles.append(capital)
    $ capital.ally.append(croc_knight)
    $ capital.ally.append(lancer)
    $ capital.ally.append(hobbits)
    $ capital.ally.append(soldiers)
    $ capital.ally.append(angels)
    $ capital.ally.append(rogues)


    show screen war_room_screen
    pause 1
    gen "Tell me what's going on."
    spy "Sir!"
    default orc_army = army_battle("Orcs", 620, 630, 240)
    $ war_room.battles.append(orc_army)
    spy "Orcs have mobilized."
    $ orc_army.enemy.append(orc_king)
    spy "They're at Tareous."
    $ orc_army.enemy.append(orcs)
    $ orc_army.enemy.append(orcs)
    spy "They have at least two battalions."
    gen "We have a battalion of amazons nearby."
    $ orc_army.ally.append(amazons)
    "..."
    $ orc_army.ally.append(soldiers)
    gen "And some soldiers."
    gen "That should stop them."
    kin "Put Ollang in charge of them."
    $ orc_army.ally.append(dwarf_king)
    gen "Yes sir!"
    default davasos = army_battle("Skeletons", 820, 300, 20)
    $ war_room.battles.append(davasos)
    spy "We have spotted some skeleton activity near Davasos."
    $ davasos.enemy.append(skeletons)
    gen "Any dead nights?"
    default gates_of_hell = army_battle("Skeletons", 700, 200, 0)
    $ war_room.battles.append(gates_of_hell)
    spy "Not there. But there are some at the games of hell."
    $ gates_of_hell.enemy.append(death_knights)
    gen "They're too close."
    gen "Anything else?"
    spy "No sir!"
    gen "Alright you're dismissed!"
    spy "Sir!"
    "..."
    gen "We can't let them join."
    kin "Do you have any suggestion?"
    call screen war_room_screen


